# Generated by rust2rpm 13
%bcond_without check

%global crate rav1e

Name:           rust-%{crate}
Version:        0.2.0
Release:        1%{?dist}
Summary:        Fastest and safest AV1 encoder

# Upstream license specification: BSD-2-Clause
License:        BSD
URL:            https://crates.io/crates/rav1e
Source:         %{crates_source}
# Partly revert https://github.com/xiph/rav1e/commit/192d56e1f4243998995b2a8a3c7e2f35acb0c3a7
# due to https://github.com/xiph/rav1e/issues/1986
Patch0:         0001-Revert-Refactor-coefficient-writing.patch
# Fix PNG feature in image dependency
Patch1:         0001-Fix-png-feature.patch
# https://github.com/xiph/rav1e/issues/1987
Patch2:         0001-Always-disable-tracing-when-testing.patch

ExclusiveArch:  %{rust_arches}
%if %{__cargo_skip_build}
BuildArch:      noarch
%endif

BuildRequires:  rust-packaging

%global _description %{expand:
Fastest and safest AV1 encoder.}

%description %{_description}

%if ! %{__cargo_skip_build}
%package     -n %{crate}
Summary:        %{summary}

%description -n %{crate} %{_description}

%files       -n %{crate}
%license LICENSE PATENTS
%doc README.md
%{_bindir}/rav1e

%package     -n %{crate}-libs
Summary:        Library files for rav1e

%description -n %{crate}-libs
Library files for rav1e, the fastest and safest AV1 encoder.

%files       -n %{crate}-libs
%license LICENSE PATENTS
%{_libdir}/librav1e.so.0*

%package     -n %{crate}-devel
Summary:        Development files for rav1e
Requires:       %{crate}-libs%{?_isa} = %{version}-%{release}

%description -n %{crate}-devel
Development files for rav1e, the fastest and safest AV1 encoder.

%files       -n %{crate}-devel
%{_includedir}/rav1e
%{_libdir}/librav1e.so
%{_libdir}/pkgconfig/rav1e.pc
%endif

%package        devel
Summary:        %{summary}
BuildArch:      noarch

%description    devel %{_description}

This package contains library source intended for building other packages
which use "%{crate}" crate.

%files          devel
%license LICENSE PATENTS
%doc README.md
%{cargo_registry}/%{crate}-%{version_no_tilde}/

%package     -n %{name}+default-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+default-devel %{_description}

This package contains library source intended for building other packages
which use "default" feature of "%{crate}" crate.

%files       -n %{name}+default-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+aom-sys-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+aom-sys-devel %{_description}

This package contains library source intended for building other packages
which use "aom-sys" feature of "%{crate}" crate.

%files       -n %{name}+aom-sys-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+asm-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+asm-devel %{_description}

This package contains library source intended for building other packages
which use "asm" feature of "%{crate}" crate.

%files       -n %{name}+asm-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+backtrace-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+backtrace-devel %{_description}

This package contains library source intended for building other packages
which use "backtrace" feature of "%{crate}" crate.

%files       -n %{name}+backtrace-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+bench-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+bench-devel %{_description}

This package contains library source intended for building other packages
which use "bench" feature of "%{crate}" crate.

%files       -n %{name}+bench-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+better-panic-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+better-panic-devel %{_description}

This package contains library source intended for building other packages
which use "better-panic" feature of "%{crate}" crate.

%files       -n %{name}+better-panic-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+binaries-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+binaries-devel %{_description}

This package contains library source intended for building other packages
which use "binaries" feature of "%{crate}" crate.

%files       -n %{name}+binaries-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+byteorder-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+byteorder-devel %{_description}

This package contains library source intended for building other packages
which use "byteorder" feature of "%{crate}" crate.

%files       -n %{name}+byteorder-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+capi-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+capi-devel %{_description}

This package contains library source intended for building other packages
which use "capi" feature of "%{crate}" crate.

%files       -n %{name}+capi-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+cc-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+cc-devel %{_description}

This package contains library source intended for building other packages
which use "cc" feature of "%{crate}" crate.

%files       -n %{name}+cc-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+check_asm-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+check_asm-devel %{_description}

This package contains library source intended for building other packages
which use "check_asm" feature of "%{crate}" crate.

%files       -n %{name}+check_asm-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+clap-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+clap-devel %{_description}

This package contains library source intended for building other packages
which use "clap" feature of "%{crate}" crate.

%files       -n %{name}+clap-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+dav1d-sys-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+dav1d-sys-devel %{_description}

This package contains library source intended for building other packages
which use "dav1d-sys" feature of "%{crate}" crate.

%files       -n %{name}+dav1d-sys-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+decode_test-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+decode_test-devel %{_description}

This package contains library source intended for building other packages
which use "decode_test" feature of "%{crate}" crate.

%files       -n %{name}+decode_test-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+decode_test_dav1d-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+decode_test_dav1d-devel %{_description}

This package contains library source intended for building other packages
which use "decode_test_dav1d" feature of "%{crate}" crate.

%files       -n %{name}+decode_test_dav1d-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+desync_finder-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+desync_finder-devel %{_description}

This package contains library source intended for building other packages
which use "desync_finder" feature of "%{crate}" crate.

%files       -n %{name}+desync_finder-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+dump_ivf-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+dump_ivf-devel %{_description}

This package contains library source intended for building other packages
which use "dump_ivf" feature of "%{crate}" crate.

%files       -n %{name}+dump_ivf-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+dump_lookahead_data-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+dump_lookahead_data-devel %{_description}

This package contains library source intended for building other packages
which use "dump_lookahead_data" feature of "%{crate}" crate.

%files       -n %{name}+dump_lookahead_data-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+image-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+image-devel %{_description}

This package contains library source intended for building other packages
which use "image" feature of "%{crate}" crate.

%files       -n %{name}+image-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+ivf-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+ivf-devel %{_description}

This package contains library source intended for building other packages
which use "ivf" feature of "%{crate}" crate.

%files       -n %{name}+ivf-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+nasm-rs-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+nasm-rs-devel %{_description}

This package contains library source intended for building other packages
which use "nasm-rs" feature of "%{crate}" crate.

%files       -n %{name}+nasm-rs-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+pretty_env_logger-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+pretty_env_logger-devel %{_description}

This package contains library source intended for building other packages
which use "pretty_env_logger" feature of "%{crate}" crate.

%files       -n %{name}+pretty_env_logger-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+quick_test-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+quick_test-devel %{_description}

This package contains library source intended for building other packages
which use "quick_test" feature of "%{crate}" crate.

%files       -n %{name}+quick_test-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+rust_hawktracer-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+rust_hawktracer-devel %{_description}

This package contains library source intended for building other packages
which use "rust_hawktracer" feature of "%{crate}" crate.

%files       -n %{name}+rust_hawktracer-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+scan_fmt-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+scan_fmt-devel %{_description}

This package contains library source intended for building other packages
which use "scan_fmt" feature of "%{crate}" crate.

%files       -n %{name}+scan_fmt-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+serde-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+serde-devel %{_description}

This package contains library source intended for building other packages
which use "serde" feature of "%{crate}" crate.

%files       -n %{name}+serde-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+serialize-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+serialize-devel %{_description}

This package contains library source intended for building other packages
which use "serialize" feature of "%{crate}" crate.

%files       -n %{name}+serialize-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+signal-hook-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+signal-hook-devel %{_description}

This package contains library source intended for building other packages
which use "signal-hook" feature of "%{crate}" crate.

%files       -n %{name}+signal-hook-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+signal_support-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+signal_support-devel %{_description}

This package contains library source intended for building other packages
which use "signal_support" feature of "%{crate}" crate.

%files       -n %{name}+signal_support-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+toml-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+toml-devel %{_description}

This package contains library source intended for building other packages
which use "toml" feature of "%{crate}" crate.

%files       -n %{name}+toml-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+tracing-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+tracing-devel %{_description}

This package contains library source intended for building other packages
which use "tracing" feature of "%{crate}" crate.

%files       -n %{name}+tracing-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%package     -n %{name}+y4m-devel
Summary:        %{summary}
BuildArch:      noarch

%description -n %{name}+y4m-devel %{_description}

This package contains library source intended for building other packages
which use "y4m" feature of "%{crate}" crate.

%files       -n %{name}+y4m-devel
%ghost %{cargo_registry}/%{crate}-%{version_no_tilde}/Cargo.toml

%prep
%autosetup -n %{crate}-%{version_no_tilde} -p1
%cargo_prep

%generate_buildrequires
# We need optional dependencies for cargo-c to build
%cargo_generate_buildrequires -a
echo "cargo-c"

%build
%cargo_build
cargo cbuild --release

%install
%cargo_install
cargo cinstall --release \
    --destdir=%{buildroot} \
    --prefix=%{_prefix} \
    --libdir=%{_libdir} \
    --includedir=%{_includedir} \
    --pkgconfigdir=%{_libdir}/pkgconfig
rm -f %{buildroot}%{_libdir}/librav1e.a

%if %{with check}
%check
%cargo_test
%endif

%changelog
* Fri Dec 20 21:32:13 CET 2019 Robert-André Mauchin <zebob.m@gmail.com> - 0.2.0-1
- Initial package
